//------------------------------------------------------------------
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"
//------------------------------------------------------------------
#include <stdlib.mqh>



extern bool    EcnBroker              = true;
extern string  SymbolsPrefix          = "";
extern string  SymbolsSuffix          = "";
extern bool    UseAutoMagic           = true;
extern int     ManualMagic            = 12129898;
extern double  Lots                   = 0.1;
extern int     Slippage               = 3;
extern int     StopLoss               = 200;
extern int     TakeProfit             = 600;
extern double  MaximumRisk            = 0.02;
extern double  DecreaseFactor         = 3;
extern bool    TrailOnlyInProfit      = false;
extern double  CloseWhenProfit        = 0.0;
extern int     InitialStop            = 25;

extern int     StepMaTimeFrame        = 0;
extern int     StepMaBarToTest        = 1;       
extern int     Length                 = 2;          // Volty Length
extern double  Kv                     = 0.95;       // Sensivity Factor
extern int     StepSize               = 0;          // Constant Step Size (if need)
extern int     MA_Mode                = 1;          // Volty MA Mode : 0-SMA, 1-LWMA 
extern int     Advance                = 0;          // Offset
extern double  Percentage             = 0;          // Percentage of Up/Down Moving
extern double  UpDownShift            = 0;          // Number of Up/Down Moving, in points. 
extern bool    HighLow                = false;      // High/Low Mode Switch (more sensitive)

extern string  __strail               = "StepMa Trail";
extern bool    UseStepMaTrail         = true;
extern int     trail.StepMaTF         = 0;
extern int     StepMaBarToTrail       = 1;       
extern int     trail.Length           = 21;         // Volty Length
extern double  trail.Kv               = 1;          // Sensivity Factor
extern int     trail.StepSize         = 0;          // Constant Step Size (if need)
extern int     trail.MA_Mode          = 0;          // Volty MA Mode : 0-SMA, 1-LWMA 
extern int     trail.Advance          = 0;          // Offset
extern double  trail.Percentage       = 0;          // Percentage of Up/Down Moving
extern double  trail.UpDownShift      = 0;          // Number of Up/Down Moving, in points.
extern bool    trail.HighLow          = false;      // High/Low Mode Switch (more sensitive) 


extern string  BE                     = "Break even settings";
extern bool    BreakEven              = false;
extern int     BreakEvenPips          = 50;
extern int     BreakEvenProfit        = 50;

extern string  _time                  = "Time Filter";
extern int     StartHour              = 8;          // Start Hour of Trade Session 
extern int     StartMinute            = 0;          // Start Minute of Trade Session 
extern int     EndHour                = 19;         // End Hour of Trade Session
extern int     EndMinute              = 0;          // End Hour of Trade Session

extern string  _os                    = "Other stuff";
extern bool    ShowAlerts             = true;
extern bool    showMessages           = true;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int    MagicNumber;
int    ColorMode = 2; 
int    digit = 0;

double PointRatio = 1;
double _Point;

string s_symbol;

//
//
//
//
//



int init() 
{
                
   s_symbol = Symbol();
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic; 
              
              
return(0);
}

//
//
//
//
//

int deinit()
{
       Comment(" ");
   switch(UninitializeReason())
   {
      case REASON_CHARTCHANGE:
      case REASON_PARAMETERS:  break;
      case REASON_RECOMPILE:
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
      case REASON_ACCOUNT:     if (showMessages) for(int i=0; i<10; i++)  ObjectDelete("msg.que"+i);
   }
   
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define SIGNAL_NONE 0
#define SIGNAL_BUY  1
#define SIGNAL_SELL 2   

//
//
//
//
//

int start()
{
   if (!CheckTerminalStatus()) return(0); showTwoStateMessage("working","StepMA EA working",true);
   
   //
   //
   //
   //
   //
   
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==3 || digit==5) 
         PointRatio = 10;
   else  PointRatio = 1; 
   _Point  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;  
   
   
   //
   //
   //
   //
   //
   
   if (UseStepMaTrail) checkStepMaTrail();
   if (BreakEven)      BreakEvenStopLoss();
   
   //
   //
   //
   //
   //
   
   int trendCurr = iCustom(s_symbol,StepMaTimeFrame,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,5,StepMaBarToTest  );
   int trendPrev = iCustom(s_symbol,StepMaTimeFrame,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,5,StepMaBarToTest+1);
      int huh = SIGNAL_NONE;
         if (trendCurr!=trendPrev)
            if (trendCurr>0)
                  huh = SIGNAL_BUY;
            else  huh = SIGNAL_SELL;
      if (huh == SIGNAL_NONE) return(0);

   //
   //
   //
   //
   //
   
      for (int i=OrdersTotal()-1; i>=0; i--)
      { 
         OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
            if (OrderSymbol()!=s_symbol)           continue;
            if (OrderMagicNumber() != MagicNumber) continue;
            
            //
            //
            //
            //
            //
            
            if (OrderType()==OP_BUY && huh == SIGNAL_SELL) 
            {
               RefreshRates();
               for(int c=0 ; c<3; c++)
               {
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),0,CLR_NONE);
                     int err=GetLastError();
                     checkError(OrderSymbol()+" buy order closed",err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146)
                     {
                        RefreshRates();
                        continue;
                     }
                     break; 
               }            
            }                        
            
            //
            //
            //
            //
            //
            
            if (OrderType()==OP_SELL && huh == SIGNAL_BUY) 
            {
               RefreshRates();
               for(c=0 ; c<3; c++)
               {
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),0,CLR_NONE);
                     err=GetLastError();
                     checkError(OrderSymbol()+" sell order closed",err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146)
                     {
                        RefreshRates();
                        continue;
                     }
                     break; 
               }                     
           }               
      }   
   
     //
     //
     //
     //
     //

      int openedOrders = 0;
      for (i=OrdersTotal()-1; i>=0; i--)
      { 
         OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
            if (OrderSymbol()!=s_symbol)           continue;
            if (OrderMagicNumber() != MagicNumber) continue;
               openedOrders++;
      }
      if (openedOrders == 0)
      {
      
         //
         //
         //
         //
         //
         
         if (huh == SIGNAL_BUY && TimeCondition())
         {
            double BStopLossLevel   = Ask - StopLoss   * _Point;
            double BTakeProfitLevel = Ask + TakeProfit * _Point;
            
            for(c=0 ; c<3; c++)
            {
       
             RefreshRates();
            if (!EcnBroker) 
            OrderSend(s_symbol,OP_BUY,LotsOptimized(),NormalizeDouble(Ask,digit),Slippage*_Point,NormalizeDouble(BStopLossLevel,digit),  
                      NormalizeDouble(BTakeProfitLevel,digit),"Buy(#" + MagicNumber + ")",MagicNumber,0,DodgerBlue);
            else
            {
            int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),NormalizeDouble(Ask,digit),Slippage*_Point,0,0,"Buy(#" + MagicNumber + ")",MagicNumber,0,Blue);
            if  (buyTicket  >= 0)
            bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),NormalizeDouble(BStopLossLevel,digit),NormalizeDouble(BTakeProfitLevel,digit),0,CLR_NONE); 
            }   
                     err=GetLastError();
                     checkError(OrderSymbol()+" buy order opened",err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146)
                     {
                        RefreshRates();
                        continue;
                     }
                     break; 
               }                     
         }
         
         //
         //
         //
         //
         //
         
         if (huh == SIGNAL_SELL && TimeCondition())
         {
               double SStopLossLevel   = Bid + StopLoss   * _Point;
               double STakeProfitLevel = Bid - TakeProfit * _Point;
              
               for(c=0 ; c<3; c++)
               {
                  RefreshRates();
               
                  if (!EcnBroker)
                    OrderSend(s_symbol,OP_SELL,LotsOptimized(),NormalizeDouble(Bid,digit),Slippage*_Point,NormalizeDouble(SStopLossLevel,digit),  
                              NormalizeDouble(STakeProfitLevel,digit),"Sell(#" + MagicNumber + ")",MagicNumber,0,DeepPink);
                  else
                  {
		            int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),NormalizeDouble(Bid,digit),Slippage*_Point,0,0,"Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
                  if(sellTicket    >= 0) 
                  bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),NormalizeDouble(SStopLossLevel,digit),NormalizeDouble(STakeProfitLevel,digit),0,CLR_NONE);
                  } 
                           err=GetLastError();
                           checkError(OrderSymbol()+" sell order opened",err);
                           if(err==4 || err==136 || err==137 || err==138 || err==146)
                           {
                              RefreshRates();
                              continue;
                   }
                   break; 
               }                     
         }
   }
return(0);      
}

//
//
//
//
//

void checkStepMaTrail()
{

   datetime startTime   = TimeCurrent();
   double   totalProfit = 0;
   int      err,c;
   
   //
   //
   //
   //
   //

   for (int i=OrdersTotal()-1; i>=0; i--)
   { 
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()!= s_symbol)            continue;
         if (OrderMagicNumber() != MagicNumber)   continue;
      RefreshRates();

      //
      //
      //
      //
      //

      if (OrderType()==OP_BUY) 
      {
         totalProfit += OrderProfit();
         double bid        = MarketInfo(OrderSymbol(),MODE_BID);
         double maxBuyStop = NormalizeDouble(bid-MarketInfo(OrderSymbol(),MODE_STOPLEVEL)*_Point,digit);
            if (OrderStopLoss()==0 && InitialStop > 0)
               {
                  double buyStop        = bid-InitialStop*_Point*PointRatio;
                  double currentBuyStop = buyStop-_Point;
               }
            else
               {             
                  buyStop        = StepMaValue(OrderSymbol());
                  currentBuyStop = OrderStopLoss(); if(currentBuyStop == 0) currentBuyStop = OrderOpenPrice();
                  currentBuyStop = MathMax(currentBuyStop,OrderOpenPrice());
               }                                          
         buyStop        = NormalizeDouble(buyStop       ,digit);
         currentBuyStop = NormalizeDouble(currentBuyStop,digit);
         
         //
         //
         //
         //
         //

         bool doModifyBuy = (buyStop > NormalizeDouble(OrderStopLoss(),digit)); if (TrailOnlyInProfit) doModifyBuy = (buyStop > currentBuyStop);
         if (doModifyBuy && (buyStop < maxBuyStop))
         for(c=0 ; c<3; c++)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(buyStop,digit),OrderTakeProfit(),0,CLR_NONE);
               err=GetLastError();
               checkError(OrderSymbol()+" buy stop loss set to "+DoubleToStr(buyStop,digit),err);
               if(err==4 || err==136 || err==137 || err==138 || err==146)
               {
                  RefreshRates();
                  continue;
               }
            break; 
         }                     
      }   

      //
      //
      //
      //
      //
      
      if (OrderType()==OP_SELL)
      {
         totalProfit += OrderProfit();
         double ask         = MarketInfo(OrderSymbol(),MODE_ASK);
         double minSellStop = NormalizeDouble(ask+MarketInfo(OrderSymbol(),MODE_STOPLEVEL)*_Point,digit);
            if (OrderStopLoss()==0 && InitialStop > 0)
               {
                  double sellStop        = ask+InitialStop*_Point*PointRatio;
                  double currentSellStop = sellStop+_Point;
               }
            else
               {             
                  sellStop        = StepMaValue(OrderSymbol());
                  currentSellStop = OrderStopLoss(); if(currentSellStop == 0) currentSellStop = OrderOpenPrice();
                  currentSellStop = MathMin(currentSellStop,OrderOpenPrice());
               }                                          
         sellStop        = NormalizeDouble(sellStop       ,digit);
         currentSellStop = NormalizeDouble(currentSellStop,digit);
         
         //
         //
         //
         //
         //
            
         bool doModifySell = (sellStop < NormalizeDouble(OrderStopLoss(),digit) || OrderStopLoss()==0); if (TrailOnlyInProfit) doModifySell = (sellStop < currentSellStop);
         if (doModifySell && (sellStop > minSellStop))
         for(c=0 ; c<3; c++)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(sellStop,digit),OrderTakeProfit(),0,CLR_NONE);
               err=GetLastError();
               checkError(OrderSymbol()+" sell stop loss set to "+DoubleToStr(sellStop,digit),err);
               if(err==4 || err==136 || err==137 || err==138 || err==146)
               {
                  RefreshRates();
                  continue;
               }
            break; 
         }                     
      }
   }
   
   //
   //
   //
   //
   //
   
   if (CloseWhenProfit>0)
   {
      if ((TimeCurrent()-startTime)>15) totalProfit = colectProfit();
      
      //
      //
      //
      //
      //
      
      if (CloseWhenProfit<totalProfit)
      for (i=OrdersTotal()-1; i>=0; i--)
      { 
         OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
       
            if (OrderSymbol()!= s_symbol)           continue;
            if (OrderMagicNumber() != MagicNumber)  continue;
      
            //
            //
            //
            //
            //
            
            if (OrderType()==OP_BUY || OrderType()==OP_SELL)
            for(c=0 ; c<3; c++)
            {
               OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,CLR_NONE);
                  err=GetLastError();
                  checkError(OrderSymbol()+" order closed",err);
                  if(err==4 || err==136 || err==137 || err==138 || err==146)
                  {
                     RefreshRates();
                     continue;
                  }
                  break; 
            }                     
      }
   }
   return(0);      
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double colectProfit()
{
   double profitSoFar=0;
   
   //
   //
   //
   //
   //
   
   for (int i=OrdersTotal()-1; i>=0; i--)
   { 
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()!= s_symbol)           continue;
         if (OrderMagicNumber() != MagicNumber)  continue;
         if (OrderType()==OP_BUY || OrderType()==OP_SELL)
               profitSoFar += OrderProfit();
   }         
   return(profitSoFar);
}

//
//
//
//
//

double StepMaValue(string symbol)
{
   double sMA = iCustom(symbol,trail.StepMaTF,"StepMA_v7",trail.Length,trail.Kv,trail.StepSize,trail.MA_Mode,trail.Advance,trail.Percentage,trail.UpDownShift,trail.HighLow,0,5,StepMaBarToTrail);
   return(sMA);
}

//
//
//
//
//

void BreakEvenStopLoss() // Move stop loss to breakeven
{

    bool result;
    for (int i=OrdersTotal()-1; i>=0; i--)
    { 
        OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
        if (OrderSymbol()!= s_symbol)            continue;
        if (OrderMagicNumber() != MagicNumber)   continue;
        RefreshRates();
    //
    //
    //
    //
    //
          
    if (OrderType()==OP_BUY)
    {
       double bid = MarketInfo(OrderSymbol(),MODE_BID);
       if (bid >= OrderOpenPrice () + (BreakEvenPips*_Point*PointRatio) && OrderStopLoss()<OrderOpenPrice())
       {
          result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(BreakEvenProfit*_Point),OrderTakeProfit(),0,CLR_NONE);
          if (result && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
            Print("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
            if (!result)
            {
               int err=GetLastError();
               if (ShowAlerts==true) Alert("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
                 Print("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
             } 
             break;          
         }
   	}               			         
     
     //
     //
     //
     //
     //
         
     if (OrderType()==OP_SELL)
     {
        double ask = MarketInfo(OrderSymbol(),MODE_ASK);
        if (ask <= OrderOpenPrice() - (BreakEvenPips*_Point*PointRatio) && (OrderStopLoss()>OrderOpenPrice()|| OrderStopLoss()==0)) 
        {
           result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(BreakEvenProfit*_Point),OrderTakeProfit(),0,CLR_NONE);
           if (result && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
             Print("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
             if (!result && ShowAlerts)
             {
                err=GetLastError();
                if (ShowAlerts==true) Alert("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
                  Print("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
              } 
              break;    
              
          }    
       }
    } 
} 


//----------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTerminalStatus()
{
   bool status=false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Conected to server",true);
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started",true);
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed",true);
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled",true);
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade terminal busy",false); break; }
         else showTwoStateMessage("busy","Trade terminal ready",true);
         
      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
   return(status);
}


//----------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=0)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();  
   int    losses   = 0;               
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
      
   if(losses > 1) lot = NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0) * lot_step;
   if(lot < lot_min) lot = lot_min;
   if(lot > lot_max) lot = lot_max;
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(1033929);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(1133928);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(1233937);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(1333936);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(1433945);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(1533944);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(1633953);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(1733962);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(1833961);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(1933910);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(2033911);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(2133912);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(2233913);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(2333914);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(2433915);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(2533916);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(2633917);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(2733918);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(2833919);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(2933920);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(3033921);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(3133922);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(3233923);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(3333924);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(3433925);
   
return(ManualMagic);
}

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   {
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd; 
   
   }    
   else
   {
   
   if (StartHour > EndHour)
   {
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24) || (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
   }
 }
return(result);
}

//
//
//
//
//

bool   msg.errState[];
string msg.errNames[];
string msg.messageText[10];
color  msg.messageColor[10];
int    msg.lastMessage=0;

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg.errNames)-1; i>-1; i--) if (msg.errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg.errNames)+1;
         i = size-1;
            ArrayResize(msg.errNames,size); msg.errNames[i] = name;
            ArrayResize(msg.errState,size); msg.errState[i] = -1;
      }

   //
   //
   //
   //
   //

   if (msg.errState[i]!= state)
   {   
      msg.errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   if(msg.lastMessage>9)
   {
      for(int i=0; i<9; i++)
      {
         msg.messageText[i] =msg.messageText[i+1];
         msg.messageColor[i]=msg.messageColor[i+1];
      }
      msg.lastMessage = 9;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg.messageText[msg.lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg.messageColor[msg.lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i<=msg.lastMessage; i++)
   {
      string name = "msg.que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER  ,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg.messageText[i],9,"Arial",msg.messageColor[i]);
   }
   msg.lastMessage++;
   WindowRedraw();
}


